classification
Title: buildbot: uncaptured python exception (smtpd), but no failure in regrtest
Type: behavior Stage:
Components: macOS, Tests Versions: Python 3.2
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: ronaldoussoren Nosy List: flox, giampaolo.rodola, richard, ronaldoussoren
Priority: normal Keywords: buildbot

Created on 2010-08-15 16:02 by flox, last changed 2012-07-21 12:21 by flox. This issue is now closed.

Messages (5)
msg113971 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-08-15 16:02
It occurs on PPC Leopard 3.x buildbot.

(...)
[184/346] test_ssl
error: uncaptured python exception,
closing channel <smtpd.SMTPChannel connected 'c' at 0x3593850>
(<class 'IndexError'>:pop from empty list
[/Users/buildbot/buildarea/3.x.parc-leopard-1/build/Lib/asyncore.py|read|79]
[/Users/buildbot/buildarea/3.x.parc-leopard-1/build/Lib/asyncore.py|handle_read_event|435]
[/Users/buildbot/buildarea/3.x.parc-leopard-1/build/Lib/asynchat.py|handle_read|128]
[/Users/buildbot/buildarea/3.x.parc-leopard-1/build/Lib/asyncore.py|recv|375]
[/Users/buildbot/buildarea/3.x.parc-leopard-1/build/Lib/test/mock_socket.py|recv|47])
(...)

http://www.python.org/dev/buildbot/all/builders/PPC%20Leopard%203.x/builds/295
msg114000 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2010-08-15 19:21
Could this be related to Issue5154?

I've noticed in the past that some asyncore/asychat tests print stacktraces as well, all of them in the testcases that use poll instead of select.
msg114902 - (view) Author: Giampaolo Rodola' (giampaolo.rodola) * (Python committer) Date: 2010-08-25 13:32
It's very hard to tell what went wrong without an actual traceback message. What I don't understand is why smtpd module is mentioned in the message, since apparently test_ssl.py doesn't use it at all.
msg114908 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2010-08-25 13:52
$ python2.7 test/test_asyncore.py -v
test_closeall (__main__.HelperFunctionTests) ... ok
test_closeall_default (__main__.HelperFunctionTests) ... ok
test_compact_traceback (__main__.HelperFunctionTests) ... ok
test_readwrite (__main__.HelperFunctionTests) ... ok
test_readwriteexc (__main__.HelperFunctionTests) ... ok
test_basic (__main__.DispatcherTests) ... ok
test_issue_8594 (__main__.DispatcherTests) ... ok
test_log (__main__.DispatcherTests) ... ok
test_log_info (__main__.DispatcherTests) ... ok
test_repr (__main__.DispatcherTests) ... ok
test_strerror (__main__.DispatcherTests) ... ok
test_unhandled (__main__.DispatcherTests) ... ok
test_send (__main__.DispatcherWithSendTests) ... ok
test_send (__main__.DispatcherWithSendTests_UsePoll) ... ok
test_bind (__main__.TestAPI_UseSelect) ... ok
test_connection_attributes (__main__.TestAPI_UseSelect) ... ok
test_create_socket (__main__.TestAPI_UseSelect) ... ok
test_handle_accept (__main__.TestAPI_UseSelect) ... ok
test_handle_close (__main__.TestAPI_UseSelect) ... ok
test_handle_connect (__main__.TestAPI_UseSelect) ... ok
test_handle_error (__main__.TestAPI_UseSelect) ... ok
test_handle_expt (__main__.TestAPI_UseSelect) ... ok
test_handle_read (__main__.TestAPI_UseSelect) ... ok
test_handle_write (__main__.TestAPI_UseSelect) ... ok
test_set_reuse_addr (__main__.TestAPI_UseSelect) ... ok
test_bind (__main__.TestAPI_UsePoll) ... ok
test_connection_attributes (__main__.TestAPI_UsePoll) ... ok
test_create_socket (__main__.TestAPI_UsePoll) ... ok
test_handle_accept (__main__.TestAPI_UsePoll) ... ok
test_handle_close (__main__.TestAPI_UsePoll) ... ok
test_handle_connect (__main__.TestAPI_UsePoll) ... ok
test_handle_error (__main__.TestAPI_UsePoll) ... ok
test_handle_expt (__main__.TestAPI_UsePoll) ... ok
test_handle_read (__main__.TestAPI_UsePoll) ... ok
test_handle_write (__main__.TestAPI_UsePoll) ... ok
test_set_reuse_addr (__main__.TestAPI_UsePoll) ... ok
test_dispatcher (__main__.FileWrapperTest) ... error: uncaptured python exception, closing channel <__main__.FileDispatcher at 0x70db48> (<type 'exceptions.AttributeError'>:file_wrapper instance has no attribute 'getsockopt' [/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py|readwrite|106] [/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py|handle_write_event|449])
ERROR
test_recv (__main__.FileWrapperTest) ... ok
test_send (__main__.FileWrapperTest) ... ok

======================================================================
ERROR: test_dispatcher (__main__.FileWrapperTest)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "test/test_asyncore.py", line 441, in test_dispatcher
    asyncore.loop(timeout=0.01, use_poll=True, count=2)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 214, in loop
    poll_fun(timeout, map)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 195, in poll2
    readwrite(obj, flags)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 119, in readwrite
    obj.handle_error()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 489, in handle_error
    self.handle_close()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 508, in handle_close
    self.close()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 396, in close
    self.socket.close()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 614, in close
    os.close(self.fd)
OSError: [Errno 9] Bad file descriptor

----------------------------------------------------------------------
Ran 39 tests in 1.445s

FAILED (errors=1)
Traceback (most recent call last):
  File "test/test_asyncore.py", line 721, in <module>
    test_main()
  File "test/test_asyncore.py", line 718, in test_main
    run_unittest(*tests)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/test/test_support.py", line 1055, in run_unittest
    _run_suite(suite)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/test/test_support.py", line 1038, in _run_suite
    raise TestFailed(err)
test.test_support.TestFailed: Traceback (most recent call last):
  File "test/test_asyncore.py", line 441, in test_dispatcher
    asyncore.loop(timeout=0.01, use_poll=True, count=2)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 214, in loop
    poll_fun(timeout, map)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 195, in poll2
    readwrite(obj, flags)
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 119, in readwrite
    obj.handle_error()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 489, in handle_error
    self.handle_close()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 508, in handle_close
    self.close()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 396, in close
    self.socket.close()
  File "/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/asyncore.py", line 614, in close
    os.close(self.fd)
OSError: [Errno 9] Bad file descriptor
msg166014 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2012-07-21 12:21
probably related to issue #5154 mentioned in previous comment: http://bugs.python.org/issue9610#msg114000
History
Date User Action Args
2012-07-21 12:21:08floxsetstatus: open -> closed
resolution: wont fix
messages: + msg166014
2010-08-25 13:52:18ronaldoussorensetmessages: + msg114908
2010-08-25 13:32:21giampaolo.rodolasetmessages: + msg114902
2010-08-25 02:30:12r.david.murraysetnosy: + giampaolo.rodola
2010-08-15 19:21:56ronaldoussorensetmessages: + msg114000
2010-08-15 16:22:28pitrousetnosy: + richard
2010-08-15 16:02:58floxcreate